package codegenerator;

import java.util.Iterator;
import java.util.Vector;



import if688.plplus.analysis.DepthFirstAdapter;
import if688.plplus.node.*;

public class CodeGenerator extends DepthFirstAdapter {
	
	private String arquivo;
	private String codigo;
	private TabelaIdentificadores identificadores = new TabelaIdentificadores();

	public CodeGenerator(String arquivo) {
		this.arquivo = arquivo + ".il";
		this.codigo = "";
	}
	
	public String getCodigo(){
		return this.codigo;
	}
	
	public void print(String maisCodigo){
		this.codigo = this.codigo.concat(maisCodigo);
	}
	
	public void println(String maisCodigo){
		this.codigo = this.codigo.concat(maisCodigo);
		this.println();
	}
	
	public void println(){
		this.codigo = this.codigo.concat("\n");
	}
	
	public void inStart(Start node)
    {
		this.println(".assembly extern mscorlib {}");
		this.println();
    	this.println(".assembly " + this.arquivo + " {	.ver 1:0:1:0 }");
    	this.println();
    	this.println(".module " + this.arquivo + ".exe");
    	this.println();
    	this.println(".class public " + this.arquivo + " {");
        defaultIn(node);
    }

    public void outStart(Start node)
    {
    	this.println("}");
    }
    
        
    public void outAVardecl(AVardecl node)
    {
    	Vector<Variavel> declaracoes = new Vector<Variavel>();
    	
    	String tipo = node.getType().toString().trim().toUpperCase();
    	
    	Variavel variavel = new Variavel("_" + ((AIdentlist)node.getIdentlist()).getIdent().getText().trim(), "", "");
    	variavel.setTipo(tipo);
    	tipo = variavel.getTipo();
    	
    	variavel.setValor("		ldc.i4 0" + '\n');
    	
    	declaracoes.add(variavel);
    	
    	if(this.identificadores.getNivelAtual() == 0){
    		String field = "	.field static ";
			field = field + tipo;
			field = field + " " + variavel.getIdentificador();
			
			this.println(field);
    	}
    	
    	EntradaGeracaoCodigo.Escopo escopo;
		if(this.identificadores.getNivelAtual() == 0){
			escopo = EntradaGeracaoCodigo.Escopo.GLOBAL; 
		}else {
			escopo = EntradaGeracaoCodigo.Escopo.LOCAL;
		}
		
		EntradaGeracaoCodigo e = new EntradaGeracaoCodigo(variavel.getIdentificador(), tipo, Entrada.Ent.VAR, escopo, null, variavel.getValor());
		this.identificadores.inserirIdentificador(e);
		
		Iterator<PSeqIdentlist> navegador = ((AIdentlist)node.getIdentlist()).getSeqIdentlist().iterator();
		ASeqIdentlist atual;
		
		while(navegador.hasNext()){
			atual = (ASeqIdentlist) navegador.next();
			variavel = new Variavel("_" + atual.getIdent().getText().trim(), "", "");
			variavel.setTipo(tipo);
			
			if(variavel.getValor().equalsIgnoreCase("")){
				variavel.setValor("		ldc.i4 0" + '\n');
			}
			
			declaracoes.addElement(variavel);
			if(this.identificadores.getNivelAtual() == 0){
				String field = "	.field static ";
				field = field + tipo;
				field = field + " " + variavel.getIdentificador();
				
				this.println(field);
			}
			
			if(this.identificadores.getNivelAtual() == 0){
				escopo = EntradaGeracaoCodigo.Escopo.GLOBAL; 
			}else {
				escopo = EntradaGeracaoCodigo.Escopo.LOCAL;
			}			
			e = new EntradaGeracaoCodigo(variavel.getIdentificador(), tipo, Entrada.Ent.VAR, escopo, null,variavel.getValor());
			this.identificadores.inserirIdentificador(e);
		}
		
		
    }
    
    
//    public void outAIdentlist(AIdentlist node)
//    {
//    	Variavel variavel = new Variavel("_" + node.getIdent().getText().trim(), "", "");
//    	setOut(node, variavel);
//    }
    
    

    
    
    
    
    
    
    
    
    
    
    
}
