package codegenerator;

import java.util.Iterator;
import java.util.Vector;

public class TabelaIdentificadores {


	private Vector<EntradaGeracaoCodigo> identificadores;
	private int nivelAtual;
	
	public TabelaIdentificadores(){
		this.identificadores = new Vector<EntradaGeracaoCodigo>();
		this.nivelAtual = 0;
	}
		
	public void abrirEscopo(){
		this.nivelAtual++;
	}
	
	public void fecharEscopo(){
		this.removerIdentificadores();
		this.nivelAtual--;
	}
	
	public void inserirIdentificador(EntradaGeracaoCodigo e)  {
		if(!this.identificadorExiste(e.getIdentificador())){
			this.identificadores.addElement(e);
		}else{
			System.out.println("identificador j existe");
			System.exit(0);
		}		
	}
	
	public void removerIdentificadores(){
		if(this.nivelAtual != 0){
			EntradaGeracaoCodigo temp;
			Vector<EntradaGeracaoCodigo> remover = new Vector<EntradaGeracaoCodigo>();
			
			for (Iterator it = this.identificadores.iterator(); it.hasNext();){
				temp = (EntradaGeracaoCodigo) it.next();
				if(temp.getTipoEntrada() == Entrada.Ent.VAR){
					if(this.nivelAtual <= temp.getEscopo().ordinal()){		
						remover.addElement(temp);
					}
				}
			}
			for(Iterator it = remover.iterator(); it.hasNext();){
				this.identificadores.removeElement(it.next());
			}
		}
	}
	
	public EntradaGeracaoCodigo getIdentificador(String identificador/*, int nivel*/){
		EntradaGeracaoCodigo retorno = null;
		Iterator it = this.identificadores.iterator();
		EntradaGeracaoCodigo temp;
		
		while(retorno == null && it.hasNext()){
			temp = (EntradaGeracaoCodigo) it.next();
			if(temp.getIdentificador().equals(identificador)/* && temp.getNivel() == nivel*/){
				retorno = temp;
			}
		}		
		return retorno;
	}
	
	public boolean identificadorExiste(String identificador){
		boolean encontrado = false;
		Iterator it = this.identificadores.iterator();
		while(!encontrado && it.hasNext()){
			if(((EntradaGeracaoCodigo) it.next()).getIdentificador().equals(identificador)){
				encontrado = true;
			}
		}		
		return encontrado;
	}
	
	public Vector<EntradaGeracaoCodigo> getFuncoes(){
		Vector<EntradaGeracaoCodigo> retorno = new Vector<EntradaGeracaoCodigo>();
		Iterator iter = this.identificadores.iterator();
		EntradaGeracaoCodigo temp;
		while(iter.hasNext()){
			temp = (EntradaGeracaoCodigo) iter.next();
			if(temp.getTipoEntrada() == Entrada.Ent.FUNC){
				retorno.addElement(temp);
			}
		}
		return retorno;
	}
	
	public EntradaGeracaoCodigo getFuncao(String id)  {
		EntradaGeracaoCodigo retorno = null;
		Iterator iter = this.getFuncoes().iterator();
		EntradaGeracaoCodigo temp;
		
		while(iter.hasNext()){
			temp = (EntradaGeracaoCodigo) iter.next();
			if(temp.getIdentificador().trim().equals(id.trim())){
				retorno = temp;
			}
		}
		if(retorno == null){
			System.out.println("idetnificador nao existe");
			System.exit(0);
		}
		return retorno;
	}
	
	public EntradaGeracaoCodigo getEntrada(String id) {
		EntradaGeracaoCodigo retorno = null;
		retorno = this.getIdentificador(id);
		/*int temp = this.getNivelAtual();
		while(temp >= 0){
			retorno = this.getIdentificador(id, temp);
			temp--;
		}*/
		if (retorno == null){
			System.out.println("idetnificador nao existe");
			System.exit(0);
		}
		return retorno;
	}
	
	public Vector<EntradaGeracaoCodigo> getIdentificadores() {
		return identificadores;
	}

	public void setIdentificadores(Vector<EntradaGeracaoCodigo> identificadores) {
		this.identificadores = identificadores;
	}

	public int getNivelAtual() {
		return nivelAtual;
	}

	public void setNivelAtual(int nivelAtual) {
		this.nivelAtual = nivelAtual;
	}
	
	public Vector<Variavel> getVariaveisLocais(){
		Vector<Variavel> retorno = new Vector<Variavel>();
		Iterator i = this.identificadores.iterator();
		EntradaGeracaoCodigo temp;
		
		while(i.hasNext()){
			temp = (EntradaGeracaoCodigo)i.next();
			if(temp.getEscopo().ordinal() == 1){
				if(temp.getTipoEntrada() == Entrada.Ent.VAR){
					if(!temp.getCodigo().equalsIgnoreCase("")){
						retorno.addElement(new Variavel(temp.getIdentificador(), temp.getTipo(), temp.getCodigo()));
					}
				}
			}
		}
		return retorno;
	}


}
